#include "pitches.h"

#define LDR PIN_PC4
#define LED PIN_PB1
#define BUZ PIN_PC1

uint16_t HBDmelody[] = {
  NOTE_C5,NOTE_C5,NOTE_D5,NOTE_C5,NOTE_F5,NOTE_E5,
  NOTE_C5,NOTE_C5,NOTE_D5,NOTE_C5,NOTE_G5,NOTE_F5,
  NOTE_C5,NOTE_C5,NOTE_C6,NOTE_A5,NOTE_F5,NOTE_E5,NOTE_D5,
  NOTE_AS5,NOTE_AS5,NOTE_A5,NOTE_F5,NOTE_G5,NOTE_F5
};

// note durations: 4 = quarter note, 8 = eighth note, etc.:
uint8_t HBDnoteDurations[] = {
  8,12,6,6,6,3,
  8,12,6,6,6,3,
  8,12,6,6,6,6,3,
  8,12,6,6,6,3     
};

uint16_t JBmelody[] = {  
  NOTE_E5,NOTE_E5,NOTE_E5,NOTE_E5,NOTE_E5,NOTE_E5,NOTE_E5,NOTE_G5,NOTE_C5,NOTE_D5,NOTE_E5,
  NOTE_F5,NOTE_F5,NOTE_F5,NOTE_F5,NOTE_F5,NOTE_F5,NOTE_E5,NOTE_E5,NOTE_E5,NOTE_E5,NOTE_E5,NOTE_D5,NOTE_D5,NOTE_E5,NOTE_D5,NOTE_G5,
  NOTE_E5,NOTE_E5,NOTE_E5,NOTE_E5,NOTE_E5,NOTE_E5,NOTE_E5,NOTE_G5,NOTE_C5,NOTE_D5,NOTE_E5,
  NOTE_F5,NOTE_F5,NOTE_F5,NOTE_F5,NOTE_F5,NOTE_F5,NOTE_E5,NOTE_E5,NOTE_E5,NOTE_E5,NOTE_G5,NOTE_G5,NOTE_F5,NOTE_D5,NOTE_C5,
};

uint8_t JBnoteDurations[] = {
  8,8,4,8,8,4,8,8,8,8,2, // 11
  8,8,8,16,16,8,8,8,16,16,8,8,8,8,4,4, // 16
  8,8,4,8,8,4,8,8,8,8,2, // 11
  8,8,8,16,16,8,8,8,16,16,8,8,8,8,2, // 15
};

uint16_t Mariomelody[] = {
  NOTE_E7, NOTE_E7, 0, NOTE_E7,
  0, NOTE_C7, NOTE_E7, 0,
  NOTE_G7, 0, 0,  0,
  NOTE_G6, 0, 0, 0,
 
  NOTE_C7, 0, 0, NOTE_G6,
  0, 0, NOTE_E6, 0,
  0, NOTE_A6, 0, NOTE_B6,
  0, NOTE_AS6, NOTE_A6, 0,
 
  NOTE_G6, NOTE_E7, NOTE_G7,
  NOTE_A7, 0, NOTE_F7, NOTE_G7,
  0, NOTE_E7, 0, NOTE_C7,
  NOTE_D7, NOTE_B6, 0, 0
};

uint8_t MarionoteDurations[] = {
  12, 12, 12, 12,
  12, 12, 12, 12,
  12, 12, 12, 12,
  12, 12, 12, 12,
 
  12, 12, 12, 12,
  12, 12, 12, 12,
  12, 12, 12, 12,
  12, 12, 12, 12,
 
  9, 9, 9,
  12, 12, 12, 12,
  12, 12, 12, 12,
  12, 12, 12, 12,
};

uint16_t Dmelody[] = {
   NOTE_G4,NOTE_C5,NOTE_C5,NOTE_D5,NOTE_C5,NOTE_B4,NOTE_A4,NOTE_A4,
   NOTE_A4,NOTE_D5,NOTE_D5,NOTE_E5,NOTE_D5,NOTE_C5,NOTE_B4,NOTE_G4,
   NOTE_G4,NOTE_E5,NOTE_E5,NOTE_F5,NOTE_E5,NOTE_D5,NOTE_C5,NOTE_A5,NOTE_G4,NOTE_G4,NOTE_A4,NOTE_D5,NOTE_B4,NOTE_C5,
   NOTE_G4,NOTE_C5,NOTE_C5,NOTE_C5,NOTE_B4,NOTE_B4,NOTE_C5,NOTE_B4,NOTE_A4,NOTE_G4,
   NOTE_D5,NOTE_E5,NOTE_D5,NOTE_D5,NOTE_C5,NOTE_C5,NOTE_G5,NOTE_G4,NOTE_G4,NOTE_G4,NOTE_A4,NOTE_D5,NOTE_B4,NOTE_C5 
};

uint8_t DnoteDurations[] = {
  4,4,8,8,8,8,4,4,
  4,4,8,8,8,8,4,4,
  4,4,8,8,8,8,4,4,8,8,4,4,4,2,
  4,4,4,4,2,4,4,4,4,2,
  4,4,8,8,8,8,4,4,8,8,4,4,4,2, 
};

void setup() {
  pinMode(LDR, INPUT);
  pinMode(LED, OUTPUT);
  pinMode(BUZ, OUTPUT);
  Serial.begin(9600);
    
}

void loop() {
  int ldr = analogRead(LDR);
  Serial.println(ldr);
  if(ldr > 500 && ldr < 700) {
    sing(1);
  }
  else if (ldr > 300 && ldr < 500) {
    sing(2);
  }
  else if (ldr > 700 && ldr < 900) {
    sing(3);
  }
  else if (ldr > 200 && ldr < 300) {
    sing(4);
  }
  else {
    digitalWrite(LED,LOW);
  }
}

int song = 0;
void sing(int s) {
  song = s;
  if(song == 1) {
    Serial.println("Happy Bithday'song~~");
    int size = sizeof(HBDmelody) / sizeof(int);
    for(int Note = 0 ; Note < size ; Note++) {
      int noteDuration = 1000 / HBDnoteDurations[Note];

      buzz(BUZ, HBDmelody[Note], noteDuration);

      int pauseBetweenNotes = noteDuration * 1.30;
      delay(pauseBetweenNotes);

      buzz(BUZ, 0, noteDuration);
    }
  }
  else if (song == 2) {
    Serial.println("Jingle Bell~~");
    int size = sizeof(JBmelody) / sizeof(int);
    for(int Note = 0 ; Note < size ; Note++) {
      int noteDuration = 1000 / JBnoteDurations[Note];

      buzz(BUZ, JBmelody[Note], noteDuration);

      int pauseBetweenNotes = noteDuration * 1.30;
      delay(pauseBetweenNotes);

      buzz(BUZ, 0, noteDuration);
    }
  }
  else if (song == 3) {
    Serial.println("Super Mario~~~");
    int size = sizeof(Mariomelody) / sizeof(int);
    for(int Note = 0 ; Note < size ; Note++) {
      int noteDuration = 1000 / MarionoteDurations[Note];

      buzz(BUZ, Mariomelody[Note], noteDuration);

      int pauseBetweenNotes = noteDuration * 1.30;
      delay(pauseBetweenNotes);

      buzz(BUZ, 0, noteDuration);
    }
  }
  else if (song == 4) {
    Serial.println("We Wish You A Merry Christmas~~~");
    int size = sizeof(Dmelody) / sizeof(int);
    for(int Note = 0 ; Note < size ; Note++) {
      int noteDuration = 1000 / DnoteDurations[Note];

      buzz(BUZ, Dmelody[Note], noteDuration);

      int pauseBetweenNotes = noteDuration * 1.30;
      delay(pauseBetweenNotes);

      buzz(BUZ, 0, noteDuration);
    }
  }
}

void buzz(int targetPin, long frequency, long length) {
  digitalWrite(LED, HIGH);
  long delayValue = 1000000 / frequency / 2;
  long numCycles = frequency * length / 1000;
  for (long i = 0; i < numCycles; i++) {
    digitalWrite(targetPin, HIGH);
    delayMicroseconds(delayValue);
    digitalWrite(targetPin, LOW);
    delayMicroseconds(delayValue);
  }
  digitalWrite(LED, LOW);
}



